const checkLogin = require('letsnet-graphed').check

module.exports = function(defaults) {

    var model = {}

    model.loginCheck = function(req, res, next) {
        if(req.session.gLogin == null || req.session.gLogin === undefined) res.redirect('/Login')
        else {
            checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.gLogin.fingerprint, logged_user: req.session.gLogin.logged_user, location: req.session.gLogin.location}, function(data) {
                if(data.statusCode != 200 || !data.document.logged_in){
                    req.session.redirectURL = req._parsedOriginalUrl.path
                    res.redirect('/Login')
                }
                else next()
            })
        }
    }

    model.loginCheckJSON = function(req, res, next) {
        if(req.session.gLogin == null || req.session.gLogin === undefined) res.status(200).send({error: true, lCode: '-E1', msg: 'Nincs bejelentkezve!', type:'session-error', func: '@graphedCheckLogin-CHECK'})
        else {
            checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.gLogin.fingerprint, logged_user: req.session.gLogin.logged_user, location: req.session.gLogin.location}, (data) => {
                if(data.statusCode != 200 || !data.document.logged_in){
                    res.status(200).send({func: data.func, lCode: "-E1", msg: "Nincs bejelentkezve!", type: "error"})
                }
                else next()
            })
        }
    }

    model.loggedInCheck = function(req, res, next) {
        if(req.session.gLogin == null || req.session.gLogin === undefined) next()
        else {
            checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.gLogin.fingerprint, logged_user: req.session.gLogin.logged_user, location: req.session.gLogin.location}, (data) => {
                if(data.statusCode == 200){
                    if(data.document.logged_in){
                        let URL = req.session.redirectURL || '/'
                        delete req.session.redirectURL
                        res.redirect(URL)
                    } else next()
                }
                else {
                    delete req.session.gLogin.fingerprint
                    delete req.session.gLogin.logged_user
                    delete req.session.gLogin
                    next()
                }
            })
        }
    }
    return model
}
